/**
 * The package contains classes implementing a 'bounding box' area around game objects. <br>
 * The abstract base class {@link Collider} provides the abstract method {@link Collider#collidesWith(Collider)},
 * which needs to be implemented by child classes to detect and decide whether or not an object with such instance really collides with the other.
 * {@link Collider} instances are to be used for game objects ({@link gameobjects}); see constructors.<br>
 * 
 * The benefit of seperating Colliders from visual representations is that the area for collisions can be smaller/bigger/other shape to improve game play experience.
 */
package collider;
